/* Disassembles ".HEX" files
   Copyright 2001-2005	Craig Franklin
   Copyright 2014-2016	Molnár Károly
*/

#pragma once

#include "labelset.h"

#define GPDASM_VERSION_STRING       ("gpdasm-" VERSION " #" REVISION " (" __DATE__ ")")

extern struct gpdasm_state {
  pic_processor_t  processor;   /* selected processor */
  proc_class_t     pclass;       /* processor pclass */
  int              format;      /* format of the output */
  int              pass;        /* 1 or 2 */
  MemBlock_t      *i_memory;    /* Instruction memory linked list. */

  char *srcfilename,            /* Source (.asm) file name */
        basefilename[BUFSIZ],   /* Basename for generating hex,list,symbol filenames. */
        hexfilename[BUFSIZ];    /* Hex (.hex) file name */

  hex_data_t                *hex_info;    /* information on input hex file */
  const gp_register_table_t *proc_regs;

  struct {                      /* Totals for errors, warnings, messages. */
    int errors;
    int warnings;
    int messages;
  } num;

  bool show_names;
  bool show_fsrn;
  bool show_config;
  bool need_sfr_equ;
  bool use_tab;

  lset_section_root_t lset_root;
} state;
